﻿Option Explicit On
Option Strict On
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient
Imports System.Data.SqlTypes
Imports System.Xml
Imports System.Text
Imports System.IO
Imports Microsoft.VisualBasic

Partial Public Class XQuery
    'Procedures for filling and typing xml columns, and executing XQuery expressions
    Private blnIsOrderXML1 As Boolean
    Private blnIsOrderXML2 As Boolean
    Private intXML1Start As Integer
    Private intXML2Start As Integer
    Private intSizeErrors As Integer
    Private blnGetIndexStats As Boolean
    Private strClick As String = vbCrLf + vbCrLf + "-- Edit the XQuery expression to return the specified data or documents" + vbCrLf + _
     "-- Click Execute XQuery Expression to display the result"
    'Temporary (hopefully)
    Private strSizeError As String = "error(s) have occurred during modifications of " + _
     "the table's xml column's content. These errors result in NULL xml column " + _
     "values. " + vbCrLf + " To correct this problem you must restart the program, " + _
     "which (by default) runs 'DBCC CLEANTABLE' on tables with xml columns. If you've set " + _
     "the CleanTablesOnStart user setting to False, change the setting to True before " + _
     "restarting the project."

    Private Sub btnFillOrderXML1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFillOrderXML1.Click
        'Fill the OrderXML1 column
        btnExecuteOrders.Enabled = False
        Me.Cursor = Cursors.WaitCursor
        OrdersControlState(False)
        txtOrderSQL.Text = ""
        txtOrdersXQResult.Text = ""
        intRows = 0
        intSizeErrors = 0
        pbFillColumn.Value = 0
        pbFillColumn.Maximum = alOrderIDs.Count
        ClearTimingData()
        My.Application.DoEvents()
        lngBytes = 0
        Dim strSQL As String = Nothing
        objTimer = New Stopwatch
        blnIsOrderXML1 = False
        strSQL = "DECLARE @OrderXML xml; " + _
         "SET @OrderXML = (SELECT OrderID, CustomerID, EmployeeID, "
        Dim blnPstOffset As Boolean = True
        Dim blnPstCorrection As Boolean = False
        If blnPstOffset Then
            'Add timezone with PST offset
            strSQL += "CONVERT(nvarchar(30), OrderDate, 126) + N'-08:00' AS OrderDate, " + _
             "CONVERT(nvarchar(30), RequiredDate, 126) + N'-08:00' AS RequiredDate, " + _
             "CONVERT(nvarchar(30), ShippedDate, 126) + N'-08:00' AS ShippedDate, "
        ElseIf blnPstCorrection Then
            'Add timezone with PST correction to Zulu
            strSQL += "CONVERT(nvarchar(30), DATEADD(hour, 8, OrderDate), 126) + N'Z' AS OrderDate, " + _
             "CONVERT(nvarchar(30), DATEADD(hour, 8, RequiredDate), 126) + N'Z' AS RequiredDate, " + _
             "CONVERT(nvarchar(30), DATEADD(hour, 8, ShippedDate), 126) + N'Z' AS ShippedDate, "
        Else
            'Add timezone without PST correction to Zulu
            strSQL += "CONVERT(nvarchar(30), OrderDate, 126) + N'Z' AS OrderDate, " + _
             "CONVERT(nvarchar(30), RequiredDate, 126) + N'Z' AS RequiredDate, " + _
             "CONVERT(nvarchar(30), ShippedDate, 126) + N'Z' AS ShippedDate, "
        End If
        strSQL += "ShipVia, Freight, ShipName, ShipAddress, ShipCity, ShipRegion, ShipPostalCode, ShipCountry " + _
        "FROM Orders AS [Order] WHERE OrderID = @OrderID FOR XML AUTO, ELEMENTS, TYPE); " + vbCrLf
        strSQL += "UPDATE Orders SET OrderXML1 = @OrderXML WHERE OrderID = @OrderID; "
        txtOrderSQL.Text = strSQL
        My.Application.DoEvents()
        intRows = UpdateOrdersXML1(strSQL, "OrderXML1")
        Me.Cursor = Cursors.Default
        OrdersControlState(True)
        chkOrderXML1Index.Enabled = True
        btnFillOrderXML1.Focus()
    End Sub

    Public Function UpdateOrdersXML1(ByVal strSQL As String, ByVal strColName As String) As Integer
        'Populate the OrderXML1 column with a FOR XML AUTO, ELMENTS, TYPE query
        btnExecuteOrders.Enabled = False
        intRows = 0
        blnIsOrderXML1 = True
        blnIsOrderXML2 = False
        Dim intOrderID As Integer
        objTimer = New Stopwatch
        With cmNwind
            .Parameters.Clear()
            .Parameters.AddWithValue("@OrderID", alOrderIDs(0))
            .CommandText = strSQL
            cnNwind.Open()
            objTimer.Start()
            Dim intRow As Integer
            Dim intMaxRows As Integer
            intMaxRows = alOrderIDs.Count
            For intRow = 0 To intMaxRows - 1
                intOrderID = CInt(alOrderIDs(intRow))
                .Parameters(0).Value = intOrderID
                Try
                    intRows += cmNwind.ExecuteNonQuery
                    pbFillColumn.Value = intRows
                    If intRows Mod 10 = 0 Then
                        txtRows.Text = intRows.ToString
                        My.Application.DoEvents()
                    End If
                Catch exc As Exception
                    txtOrdersXQResult.Text += exc.Message + vbCrLf
                    'Temporary: Issue with size errors
                    If exc.Message.Contains("Cannot create") Then
                        intSizeErrors += 1
                        txtOrdersXQResult.Text += "OrderID: " + intOrderID.ToString
                    ElseIf exc.Message.Contains("XML Validation") Then
                        txtOrdersXQResult.Text += exc.Message + vbCrLf
                        Exit For
                    End If
                    Application.DoEvents()
                End Try
            Next
            dblTime = objTimer.ElapsedTime
            objTimer.Done()
            txtTime.Text = dblTime.ToString("0.000")
            .Parameters.Clear()
            cnNwind.Close()
            If intSizeErrors > 0 Then
                Dim strMsg As String = intSizeErrors.ToString + " " + strSizeError
                MsgBox(strMsg, MsgBoxStyle.Critical, "Row Size Errors During Fill")
            End If
            intXML1Start = CInt(alOrderIDs(alOrderIDs.Count - 1)) + 1
            txtOrdersXQResult.Text += SaveAndDisplayData2("Orders", strColName, 0)
            lngBytes = txtOrdersXQResult.Text.Length * intRows
            If chkBytes.Checked Then
                lblRowsPerSec.Text = "~KB/Sec:"
                Dim dblKB As Double = lngBytes / 1000
                txtRows.Text = dblKB.ToString("#,##0.0")
                txtRowsPerSec.Text = (dblKB / dblTime).ToString("#0.0")
            Else
                txtRows.Text = intRows.ToString
                txtRowsPerSec.Text = (intRows / dblTime).ToString("#0.0")
            End If
            Return intRows
        End With
    End Function

    Private Sub btnFillOrderXML2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFillOrderXML2.Click
        'Fill the OrderXML2 column
        btnExecuteOrders.Enabled = False
        Me.Cursor = Cursors.WaitCursor
        OrdersControlState(False)
        txtOrderSQL.Text = ""
        txtOrdersXQResult.Text = ""
        Dim strSQL As String
        Dim intOrderID As Integer
        Dim intRow As Integer
        objTimer = New Stopwatch

        blnIsOrderXML2 = True
        intRows = 0
        intSizeErrors = 0
        pbFillColumn.Value = 0
        pbFillColumn.Maximum = alOrderIDs.Count
        ClearTimingData()
        My.Application.DoEvents()
        lngBytes = 0
        cmNwind.Parameters.Add("@OrderID", SqlDbType.Int)
        cmNwind.Parameters(0).Direction = ParameterDirection.Input
        cnNwind.Open()
        Dim intMaxRows As Integer
        intMaxRows = alOrderIDs.Count
        objTimer.Start()
        For intRow = 0 To intMaxRows - 1
            intOrderID = CInt(alOrderIDs(intRow))
            Try
                strSQL = "UPDATE Orders "
                strSQL += "SET OrderXML2 = N'" + CreateOrderXML2Doc(intOrderID) + _
                 "' WHERE OrderID = @OrderID; "
                cmNwind.CommandText = strSQL
                intRows += cmNwind.ExecuteNonQuery
                pbFillColumn.Value = intRows
                If intRow = 0 Then
                    txtOrderSQL.Text = strSQL
                    My.Application.DoEvents()
                End If
                If intRows Mod 10 = 0 Then
                    txtRows.Text = intRows.ToString
                    My.Application.DoEvents()
                End If
            Catch exc As Exception
                If exc.Message.Contains("Cannot create") Then
                    txtOrdersXQResult.Text += "OrderID: " + intOrderID.ToString
                    intSizeErrors += 1
                End If
                txtOrdersXQResult.Text = exc.Message + vbCrLf
                My.Application.DoEvents()
            End Try
        Next
        dblTime = objTimer.ElapsedTime
        objTimer.Done()
        cmNwind.Parameters.Clear()
        txtTime.Text = dblTime.ToString("0.000")
        cnNwind.Close()
        If intSizeErrors > 0 Then
            Dim strMsg As String = intSizeErrors.ToString + " " + strSizeError
            MsgBox(strMsg, MsgBoxStyle.Critical, "Row Size Errors During Fill")
        End If
        'Last OrderID
        intXML2Start = CInt(alOrderIDs(alOrderIDs.Count - 1)) + 1
        txtOrdersXQResult.Text = SaveAndDisplayData2("Orders", "OrderXML2", intOrderID)
        If chkBytes.Checked Then
            lblRowsPerSec.Text = "KB/Sec:"
            Dim dblKB As Double = lngBytes / 1000
            txtRows.Text = dblKB.ToString("#,##0.0")
            txtRowsPerSec.Text = (dblKB / dblTime).ToString("#0.0")
        Else
            txtRows.Text = intRows.ToString
            txtRowsPerSec.Text = (intRows / dblTime).ToString("#0.0")
        End If
        Me.Cursor = Cursors.Default
        OrdersControlState(True)
        chkOrderXML2Index.Enabled = True
        btnFillOrderXML2.Focus()
    End Sub

    Private Function CreateOrderXML2Doc(ByVal intOrderID As Integer) As String
        '***Rev 1, 7/23/2005, RJ Fixes to replace SqlRecord and ExecuteRow with
        'SqlDataReader and ExecuteReader
        'Create the SalesOrder XML document with an XmlWriter
        'Dim sdrOrder As SqlRecord = Nothing
        Dim sdrOrder As SqlDataReader
        Dim strSQL As String = Nothing
        Dim decFreight As Decimal
        strSQL = "SELECT o.OrderID, o.CustomerID, c.CompanyName, c.ContactName, " + _
         "c.ContactTitle, c.Address, c.City, c.Region, c.PostalCode, c.Country, " + _
         "c.Phone, o.EmployeeID, e.FirstName, e.LastName, e.Title, e.Extension, " + _
         "o.OrderDate, o.RequiredDate, o.ShippedDate, o.ShipVia, s.CompanyName, " + _
         "o.Freight, o.ShipName, o.ShipAddress, o.ShipCity, o.ShipRegion, " + _
         "o.ShipPostalCode, o.ShipCountry " + _
         "FROM Orders AS o, Customers AS c, Employees AS e, Shippers AS s " + _
         "WHERE o.OrderID = @OrderID " + _
         "AND c.CustomerID = o.CustomerID AND e.EmployeeID = o.EmployeeID " + _
         "AND s.ShipperID = o.ShipVia"
        Try
            With cmNwind
                .Parameters(0).Value = intOrderID
                .CommandText = strSQL
                '***Rev 1
                'sdrOrder = .ExecuteRow
                sdrOrder = .ExecuteReader
                sdrOrder.Read()
            End With
        Catch exc As Exception
            Return "Error executing query"
        End Try
        If sdrOrder Is Nothing Then
            '***Rev 1
            'Return "Order is missing"
        End If
        If Not sdrOrder.HasRows Then
            '***Rev 1
            Return "Order is missing"
        End If
        Dim sbOrder As New StringBuilder
        Dim xwSettings As New XmlWriterSettings
        With xwSettings
            .Encoding = Encoding.Unicode
            .Indent = True
            .IndentChars = ("  ")
            .OmitXmlDeclaration = False
            .ConformanceLevel = ConformanceLevel.Document
        End With
        Dim xwOrder As XmlWriter = XmlWriter.Create(sbOrder, xwSettings)
        Dim strNwNs As String = "http://www.northwind.com/schemas/"
        Dim strNwSo As String = strNwNs + "SalesOrder"
        Dim strNwBt As String = strNwNs + "BillTo"
        Dim strNwSc As String = strNwNs + "SalesContact"
        Dim strNwSt As String = strNwNs + "ShipTo"

        With xwOrder
            .WriteStartElement("nwso", "SalesOrder", strNwSo)
            .WriteAttributeString("nwso", "OrderID", strNwSo, sdrOrder.GetInt32(0).ToString)
            .WriteAttributeString("nwso", "OrderDate", strNwSo, sdrOrder.GetDateTime(16).ToUniversalTime.ToString("yyyy-MM-ddTHH:mm:ssZ"))
            .WriteAttributeString("nwso", "CustomerID", strNwSo, sdrOrder.GetString(1))
            .WriteAttributeString("nwso", "EmployeeID", strNwSo, sdrOrder.GetInt32(11).ToString)
            .WriteAttributeString("nwso", "PaymentID", strNwSo, "1")
            .WriteAttributeString("nwso", "CurrencyID", strNwSo, "1")
            .WriteAttributeString("nwso", "FobID", strNwSo, "1")
            .WriteAttributeString("nwso", "ShipperID", strNwSo, sdrOrder.GetInt32(19).ToString)
            .WriteElementString("nwso", "SalesOrderNumber", strNwSo, sdrOrder.GetInt32(0).ToString)
            .WriteElementString("nwso", "SalesOrderDate", strNwSo, sdrOrder.GetDateTime(16).ToUniversalTime.ToString("yyyy-MM-ddTHH:mm:ssZ"))
            .WriteStartElement("nwso", "Terms", strNwSo)
            .WriteElementString("nwso", "Payment", strNwSo, "Net 30 Days")
            .WriteElementString("nwso", "Currency", strNwSo, "US$")
            .WriteEndElement() 'Terms
            .WriteStartElement("nwso", "Shipment", strNwSo)
            .WriteElementString("nwso", "FOB", strNwSo, "Redmond, WA")
            .WriteElementString("nwso", "Shipper", strNwSo, sdrOrder.GetString(20))
            .WriteElementString("nwso", "EstimatedFreight", strNwSo, sdrOrder.GetDecimal(21).ToString("#0.00"))
            .WriteEndElement() 'Shipment
            .WriteStartElement("nwbt", "BillTo", strNwBt)
            .WriteElementString("nwbt", "Name", strNwBt, sdrOrder.GetString(2))
            .WriteElementString("nwbt", "Address", strNwBt, sdrOrder.GetString(5))
            .WriteElementString("nwbt", "City", strNwBt, sdrOrder.GetString(6))
            If sdrOrder.IsDBNull(7) Then
                .WriteElementString("nwbt", "Region", strNwBt, "")
            Else
                .WriteElementString("nwbt", "Region", strNwBt, sdrOrder.GetString(7))
            End If
            If sdrOrder.IsDBNull(8) Then
                .WriteElementString("nwbt", "PostalCode", strNwBt, "")
            Else
                .WriteElementString("nwbt", "PostalCode", strNwBt, sdrOrder.GetString(8))
            End If
            .WriteElementString("nwbt", "Country", strNwBt, sdrOrder.GetString(9))
            .WriteStartElement("nwbt", "Buyer", strNwBt)
            .WriteElementString("nwbt", "Name", strNwBt, sdrOrder.GetString(3))
            .WriteElementString("nwbt", "Title", strNwBt, sdrOrder.GetString(4))
            .WriteElementString("nwbt", "Phone", strNwBt, sdrOrder.GetString(10))
            Dim strEmail As String = sdrOrder.GetString(3)
            strEmail = Replace(strEmail, " ", "_") + "@mail.msn.com"
            .WriteElementString("nwbt", "EMail", strNwBt, strEmail)
            Dim strPurch As String = Now.Ticks.ToString.Substring(12)
            .WriteElementString("nwbt", "PurchaseOrder", strNwBt, strPurch)
            .WriteEndElement() 'Buyer
            .WriteEndElement() 'BillTo
            .WriteStartElement("nwsc", "SalesContact", strNwSc)
            Dim strEmplName As String = sdrOrder.GetString(12) + _
             " " + sdrOrder.GetString(13).ToString
            .WriteElementString("nwsc", "Name", strNwSc, strEmplName)
            .WriteElementString("nwsc", "Title", strNwSc, sdrOrder.GetString(14))
            Dim strEmpPhone As String = "(925) 555-8081 X" + sdrOrder.GetString(15)
            .WriteElementString("nwsc", "Phone", strNwSc, strEmpPhone)
            strEmail = sdrOrder.GetString(12).ToString.Substring(0, 1).ToLower
            strEmail += sdrOrder.GetString(13).ToLower + "@northwind.com"
            .WriteElementString("nwsc", "EMail", strNwSc, strEmail)
            .WriteEndElement() 'SalesContact
            .WriteStartElement("nwso", "OrderDates", strNwSo)
            .WriteElementString("nwso", "OrderDate", strNwSo, sdrOrder.GetDateTime(16).ToUniversalTime.ToString("yyyy-MM-ddTHH:mm:ssZ"))
            .WriteElementString("nwso", "RequiredDate", strNwSo, sdrOrder.GetDateTime(17).ToUniversalTime.ToString("yyyy-MM-ddTHH:mm:ssZ"))
            .WriteEndElement() 'OrderDates
            .WriteStartElement("nwst", "ShipTo", strNwSt)
            .WriteElementString("nwst", "Name", strNwSt, sdrOrder.GetString(22))
            .WriteElementString("nwst", "Address", strNwSt, sdrOrder.GetString(23))
            .WriteElementString("nwst", "City", strNwSt, sdrOrder.GetString(24))
            If sdrOrder.IsDBNull(25) Then
                .WriteElementString("nwst", "Region", strNwSt, "")
            Else
                .WriteElementString("nwst", "Region", strNwSt, sdrOrder.GetString(25))
            End If
            If sdrOrder.IsDBNull(26) Then
                .WriteElementString("nwst", "PostalCode", strNwSt, "")
            Else
                .WriteElementString("nwst", "PostalCode", strNwSt, sdrOrder.GetString(26))
            End If
            .WriteElementString("nwst", "Country", strNwSt, sdrOrder.GetString(27))
            .WriteEndElement() 'ShipTo
            .WriteStartElement("nwso", "LineItems", strNwSo)
        End With

        '***Rev1 Get Freight amount for summary
        decFreight = sdrOrder.GetDecimal(21)
        'Close SqlDataReader
        sdrOrder.Close()

        'Add line items with full product descriptions
        Dim intItem As Integer
        Dim intItems As Integer
        Dim decAmount As Decimal

        '***Rev1 Change from sdrOrder.GetInt32(0) to intOrderID below
        strSQL = "SELECT d.ProductID, p.ProductName, p.QuantityPerUnit, " + _
        "d.Quantity, d.UnitPrice, d.Discount " + _
        "FROM [Order Details] AS d, Products AS p " + _
        "WHERE d.OrderID = " + intOrderID.ToString + _
        " AND p.ProductID = d.ProductID"

        Dim sdrItem As SqlDataReader = Nothing
        Try
            With cmNwind
                .CommandText = strSQL
                sdrItem = .ExecuteReader
            End With
        Catch exc As Exception
            If Not sdrItem.IsClosed Then
                sdrItem.Close()
            End If
            Return exc.Message
        End Try
        With sdrItem
            If .HasRows Then
                While .Read
                    intItem += 1
                    xwOrder.WriteStartElement("nwso", "LineItem", strNwSo)
                    '***Rev1 Change from sdrOrder.GetInt32(0) to intOrderID
                    'xwOrder.WriteAttributeString("nwso", "OrderID", strNwSo, sdrOrder.GetInt32(0).ToString)
                    xwOrder.WriteAttributeString("nwso", "OrderID", strNwSo, intOrderID.ToString)
                    xwOrder.WriteAttributeString("nwso", "ProductID", strNwSo, .GetInt32(0).ToString)
                    xwOrder.WriteAttributeString("nwso", "ItemID", strNwSo, intItem.ToString)
                    xwOrder.WriteElementString("nwso", "ItemNumber", strNwSo, intItem.ToString)
                    xwOrder.WriteElementString("nwso", "Ordered", strNwSo, .GetInt16(3).ToString)
                    xwOrder.WriteElementString("nwso", "SKU", strNwSo, .GetInt32(0).ToString)
                    xwOrder.WriteElementString("nwso", "Product", strNwSo, .GetString(1))
                    xwOrder.WriteElementString("nwso", "Package", strNwSo, .GetString(2))
                    xwOrder.WriteElementString("nwso", "ListPrice", strNwSo, .GetDecimal(4).ToString("#0.00"))
                    'Following accommodates real and decimal data types
                    Dim decDisc As Decimal = CDec(.GetValue(5))
                    xwOrder.WriteElementString("nwso", "Discount", strNwSo, (100 * CDec(.GetValue(5))).ToString("#0.0"))
                    Dim decExt As Decimal = .GetInt16(3) * .GetDecimal(4) * (1 - decDisc)
                    xwOrder.WriteElementString("nwso", "Extended", strNwSo, (decExt.ToString("0.00")))
                    xwOrder.WriteEndElement() 'LineItem
                    intItems += CInt(.GetInt16(3))
                    decAmount += decExt
                End While
                .Close()
            Else
                Return ""
            End If
        End With
        With xwOrder
            .WriteEndElement() 'LineItems
            .WriteStartElement("nwso", "Summary", strNwSo)
            .WriteElementString("nwso", "ItemsOrdered", strNwSo, intItems.ToString)
            .WriteElementString("nwso", "Subtotal", strNwSo, decAmount.ToString("0.00"))
            '***Rev1: Replace sdrOrder.GetDecimal(21) with decFreight
            '.WriteElementString("nwso", "EstimatedFreight", strNwSo, sdrOrder.GetDecimal(21).ToString("0.00"))
            .WriteElementString("nwso", "EstimatedFreight", strNwSo, decFreight.ToString("0.00"))
            'Dim decTotal As Decimal = decAmount + sdrOrder.GetDecimal(21)
            Dim decTotal As Decimal = decAmount + decFreight
            .WriteElementString("nwso", "Total", strNwSo, decTotal.ToString("0.00"))
            .WriteEndElement() 'Summary
            .WriteEndElement() 'SalesOrder
            .Flush()
            .Close()
        End With
        Dim strOrderXML2 As String = sbOrder.ToString
        lngBytes += strOrderXML2.Length
        'Fixup for '
        Return Replace(strOrderXML2, "'", "''")
    End Function

    Private Function SaveAndDisplayData2(ByVal strTableName As String, ByVal strColName As String, ByVal intOrderID As Integer) As String
        Try
            'Display the last row formatted 
            '(version 2 replaces an XmlTextWriter and file with an XmlWriter and StringBuilder)
            Dim strXmlFile As String = Application.StartupPath + "\" + strColName + ".xml"
            Dim strSQL As String = "SELECT " + strColName + " FROM " + strTableName
            If intOrderID > 0 Then
                strSQL += " WHERE OrderID = " + intOrderID.ToString + "; "
            Else
                If strColName.Contains("Order") Then
                    strSQL += " WHERE OrderID = " + alOrderIDs(alOrderIDs.Count - 1).ToString + "; "
                End If
            End If
            cmNwind.CommandText = strSQL
            cnNwind.Open()
            Dim xrData As XmlReader = cmNwind.ExecuteXmlReader
            Dim xwSettings As XmlWriterSettings
            Dim xwData As XmlWriter = Nothing
            sbXML = New StringBuilder()
            xwSettings = New XmlWriterSettings
            With xwSettings
                .Encoding = Encoding.Unicode
                .Indent = True
                .IndentChars = ("  ")
                .OmitXmlDeclaration = False
                .ConformanceLevel = ConformanceLevel.Document
            End With
            'Create an XmlWriter to format the result
            xwData = XmlWriter.Create(sbXML, xwSettings)
            xrData.MoveToContent()
            xwData.WriteNode(xrData, False)
            xwData.Flush()
            xwData.Close()
            cnNwind.Close()
            Return sbXML.ToString
        Catch exc As Exception
            Return "Error: " + exc.Message
        Finally
            cnNwind.Close()
        End Try
    End Function

    Private Sub chkOrderXML1Schema_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkOrderXML1Schema.CheckedChanged
        If blnBypassHandler Then
            blnBypassHandler = False
            Return
        End If
        'Create or drop the XmlSchemaCollection
        btnExecuteOrders.Enabled = False
        Me.Cursor = Cursors.WaitCursor
        txtOrderSQL.Text = ""
        txtOrdersXQResult.Text = ""
        Dim strSchemaTable As String
        Dim strSO As String = Nothing
        strSchemaTable = "Orders"
        If chkOrderXML1Schema.Checked Then
            txtOrderSQL.Text = CreateXmlSchemaCollection(strSchemaTable, "OrderXML1")
            txtOrdersXQResult.Text = ReadXmlSchemaCollection(strSO + "OrderXML1", "") + vbCrLf
        Else
            txtOrderSQL.Text = DropXmlSchemaCollection(strSchemaTable, "OrderXML1")
        End If
        If chkOrderXML1Index.Checked Then
            Dim strMsg As String = "Repopulating the " + strSchemaTable + _
             "'s OrderXML1 column is faster without indexes." + vbCrLf + vbCrLf + _
             "Do you want to defer adding indexes until after adding documents?"
            If MsgBox(strMsg, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "The Dropped xml Column had Indexes") = MsgBoxResult.No Then
                'Recreate the indexes
                CreateOrderXMLIndexes(strSchemaTable, "OrderXML1")
            Else
                blnBypassHandler = True
                chkOrderXML1Index.Checked = False
                blnBypassHandler = False
            End If
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub chkOrderXML2Schema_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkOrderXML2Schema.CheckedChanged
        If blnBypassHandler Then
            blnBypassHandler = False
            Return
        End If
        'Create or drop the XmlSchemaCollection
        btnExecuteOrders.Enabled = False
        Me.Cursor = Cursors.WaitCursor
        txtOrderSQL.Text = ""
        txtOrdersXQResult.Text = ""
        Dim strSchemaTable As String
        strSchemaTable = "Orders"

        If chkOrderXML2Schema.Checked Then
            txtOrderSQL.Text = CreateXmlSchemaCollection(strSchemaTable, "OrderXML2")
            'Display the entire schema collection
            txtOrdersXQResult.Text = ReadXmlSchemaCollection("OrderXML2", "http://www.northwind.com/schemas/SalesOrder")
            txtOrdersXQResult.Text += ReadXmlSchemaCollection("OrderXML2", "http://www.northwind.com/schemas/BillTo")
            txtOrdersXQResult.Text += ReadXmlSchemaCollection("OrderXML2", "http://www.northwind.com/schemas/SalesContact")
            txtOrdersXQResult.Text += ReadXmlSchemaCollection("OrderXML2", "http://www.northwind.com/schemas/ShipTo") + vbCrLf
        Else
            txtOrderSQL.Text = DropXmlSchemaCollection(strSchemaTable, "OrderXML2")
        End If
        If chkOrderXML2Index.Checked Then
            Dim strMsg As String = "Repopulating the " + strSchemaTable + _
             "'s OrderXML2 column is faster without indexes." + vbCrLf + vbCrLf + _
             "Do you want to defer adding indexes until after adding documents?"
            If MsgBox(strMsg, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "The Dropped xml Column had Indexes") = MsgBoxResult.No Then
                'Recreate the indexes
                CreateOrderXMLIndexes(strSchemaTable, "OrderXML2")
            Else
                blnBypassHandler = True
                chkOrderXML2Index.Checked = False
                blnBypassHandler = False
            End If
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Function ReadXmlSchemaCollection(ByVal strColName As String, ByVal strNamespace As String) As String
        'Read the XML SchemaCollection with an XmlReader and format with an XmlTextWriter
        Try
            Dim strSQL As String = "SELECT xml_schema_namespace(N'dbo',N'" + strColName + "SchemaColl')"
            If strNamespace.Length > 0 Then
                strSQL += ".query('/xs:schema[@targetNamespace=""" + strNamespace + """]')"
            End If
            cmNwind.CommandText = strSQL
            cnNwind.Open()
            'Read the schema and save to a file with an XmlTextWriter
            Dim xrSchema As XmlReader = cmNwind.ExecuteXmlReader
            cnNwind.Close()
            Dim strXsdFile As String = Application.StartupPath + "\" + strColName + "SchemaColl.xsd"
            Dim xtwSchema As New XmlTextWriter(strXsdFile, Encoding.Unicode)
            xtwSchema.Formatting = Formatting.Indented
            xrSchema.MoveToContent()
            xtwSchema.WriteNode(xrSchema, False)
            xtwSchema.Flush()
            xtwSchema.Close()
            xrSchema.Close()
            'temporary
            If File.Exists(strXsdFile) Then
                Return File.ReadAllText(strXsdFile)
            Else
                Return strSQL + vbCrLf + " did not find a schema."
            End If
        Catch exc As Exception
            Return exc.Message
        Finally
            cnNwind.Close()
        End Try
    End Function

    Private Function CreateXmlSchemaCollection(ByVal strTableName As String, ByVal strColName As String) As String
        'Create a SchemaCollection from local .xsd file(s)
        Try
            Dim strSQL As String = Nothing
            Dim strXsdFile As String = Application.StartupPath + "\" + strColName + ".xsd"
            If File.Exists(strXsdFile) Then
                Dim strSchema As String = File.ReadAllText(strXsdFile)
                DropXMLIndexes(strTableName, strColName, False)
                strSQL = "ALTER TABLE " + strTableName + " DROP COLUMN " + strColName + "; " + vbCrLf
                strSQL += "CREATE XML SCHEMA COLLECTION " + strColName + "SchemaColl " + vbCrLf
                strSQL += "AS N'" + strSchema + "'; " + vbCrLf
                strSQL += "ALTER TABLE " + strTableName + " ADD " + strColName + " xml " + _
                 "(DOCUMENT " + strColName + "SchemaColl) NULL; "
                strSQL = Replace(strSQL, ControlChars.Tab, "  ")
                cmNwind.CommandText = strSQL
                If cnNwind.State <> ConnectionState.Open Then
                    cnNwind.Open()
                End If
                If cmNwind.ExecuteNonQuery = -1 Then
                    cnNwind.Close()
                    Return "-- Click Fill " + strColName + " to repopulate the column" + vbCrLf + strSQL
                Else
                    cnNwind.Close()
                    Return "Error"
                End If
            Else
                Return "File '" + strXsdFile + "' is missing."
            End If
        Catch exc As Exception
            Return exc.Message
        Finally
            cnNwind.Close()
        End Try
    End Function

    Private Sub chkOrderXML1Index_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkOrderXML1Index.CheckedChanged
        If blnBypassHandler Then
            Return
        End If
        btnExecuteOrders.Enabled = False
        blnGetIndexStats = True
        'Create the specified index on OrderXML1
        txtOrderSQL.Text = ""
        txtOrdersXQResult.Text = ""
        Dim strIndexTable As String
        strIndexTable = "Orders"
        If chkOrderXML1Index.Checked Then
            txtOrderSQL.Text = CreateOrderXMLIndexes(strIndexTable, "OrderXML1")
            txtOrdersXQResult.Text = GetXMLIndexStats(strIndexTable, "OrderXML1")
            If Not txtOrdersXQResult.Text.Contains("pidx_OrderXML1") Then
                txtOrdersXQResult.Text += "Index Name: ?idx_OrderXML1 stats won't appear until you add some XML content."
            End If
        Else
            txtOrderSQL.Text = DropXMLIndexes(strIndexTable, "OrderXML1", False)
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub chkOrderXML2Index_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkOrderXML2Index.CheckedChanged
        'Create the specified index on OrderXML2
        If blnBypassHandler Then
            Return
        End If
        btnExecuteOrders.Enabled = False
        blnGetIndexStats = True
        txtOrderSQL.Text = ""
        txtOrdersXQResult.Text = ""
        Dim strIndexTable As String
        strIndexTable = "Orders"
        If chkOrderXML2Index.Checked Then
            txtOrderSQL.Text = CreateOrderXMLIndexes(strIndexTable, "OrderXML2")
            txtOrdersXQResult.Text = GetXMLIndexStats(strIndexTable, "OrdersXML2")
            If Not txtOrdersXQResult.Text.Contains("pidx_OrderXML2") Then
                txtOrdersXQResult.Text += "Index Name: ?idx_OrderXML2 stats won't appear until you add some XML content."
            End If
        Else
            txtOrderSQL.Text = DropXMLIndexes(strIndexTable, "OrderXML2", False)
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Function CreateOrderXMLIndexes(ByVal strTableName As String, ByVal strColName As String) As String
        'Create primary and optional secondary XML indexes
        OrdersControlState(False)
        ClearTimingData()
        objTimer = New Stopwatch
        Me.Cursor = Cursors.WaitCursor
        My.Application.DoEvents()
        Dim strSQL As String = Nothing
        'Might take a long time
        cmNwind.CommandTimeout = 300
        Try
            strSQL = "CREATE PRIMARY XML INDEX pidx_" + strColName + _
             " ON " + strTableName + " (" + strColName + "); " + vbCrLf
            If (strColName.Contains("XML1") And chkOrderXML1IndexPath.Checked) Or _
             (strColName.Contains("XML2") And chkOrderXML2IndexPath.Checked) Then
                strSQL += "CREATE XML INDEX sidx_path_" + strColName + " ON " + strTableName + _
                 " (" + strColName + ") USING XML INDEX pidx_" + strColName + " FOR PATH; " + vbCrLf
            End If
            If (strColName.Contains("XML1") And chkOrderXML1IndexValue.Checked) Or _
             (strColName.Contains("XML2") And chkOrderXML2IndexValue.Checked) Then
                strSQL += "CREATE XML INDEX sidx_value_" + strColName + " ON " + strTableName + _
                 " (" + strColName + ") USING XML INDEX pidx_" + strColName + " FOR VALUE; " + vbCrLf
            End If
            If (strColName.Contains("XML1") And chkOrderXML1IndexProp.Checked) Or _
             (strColName.Contains("XML2") And chkOrderXML2IndexProp.Checked) Then
                strSQL += "CREATE XML INDEX sidx_prop_" + strColName + " ON " + strTableName + _
                 " (" + strColName + ") USING XML INDEX pidx_" + strColName + " FOR PROPERTY; " + vbCrLf
            End If
            cmNwind.CommandText = strSQL
            If cnNwind.State <> ConnectionState.Open Then
                cnNwind.Open()
            End If
            objTimer.Start()
            cmNwind.ExecuteNonQuery()
            txtTime.Text = objTimer.ElapsedTime.ToString("#0.000")
            objTimer.Done()
            cnNwind.Close()
            Return "-- Click Fill " + strColName + " to repopulate the Orders column" + vbCrLf + strSQL
        Catch exc As Exception
            Return exc.Message + vbCrLf + vbCrLf + strSQL
        Finally
            cnNwind.Close()
            cmNwind.CommandTimeout = 30
            OrdersControlState(True)
            Me.Cursor = Cursors.Default
        End Try
    End Function

    Private Function GetXMLIndexStats(ByVal strTableName As String, ByVal strColName As String) As String
        'Get index statistics and defragment by rebuilding or reorganzing indexes, if necessary
        Try
            '***Rev 1: dm_db_index_physical_stats changed again in the SQL Server 2005 June CTP
            'Dim strSQL As String = "SELECT * FROM sys.dm_db_index_physical_stats ('" + strTableName + "', '*' , DEFAULT, 'DETAILED')"
            Dim strSQL As String = "SELECT object_id FROM sys.objects WHERE name = 'Orders'"
            Dim strObjectID As String
            Dim strStats As String = Nothing
            cmNwind.CommandText = strSQL
            cnNwind.Open()
            strObjectID = cmNwind.ExecuteScalar().ToString
            'Join required to return index name
            strSQL = "SELECT ix.name, dm.index_type_desc, dm.page_count, dm.avg_fragmentation_in_percent " + _
            "FROM sys.dm_db_index_physical_stats (DB_ID(), " + strObjectID + ", NULL, NULL, 'LIMITED') AS dm " + _
            "INNER JOIN sys.indexes ix ON dm.object_id = ix.object_id AND dm.index_id = ix.index_id " + _
            "ORDER BY ix.index_id;"
            cmNwind.CommandText = strSQL
            Dim sdrStats As SqlDataReader = cmNwind.ExecuteReader
            With sdrStats
                If .HasRows Then
                    While .Read
                        'Note: sys.dm_db_index_physical_stats structure changed in February CTP
                        '***Rev 1: 
                        'If (Not .IsDBNull(6)) AndAlso .GetString(6) = "LEAF" Then
                        'strStats += "Index Name: " + .GetString(1) + ", Type: " + _
                        '.GetString(3) + ", Pages: " + .GetInt64(10).ToString("#,##0") + _
                        '", Avg. Frag: " + .GetDouble(7).ToString("#0.00") + "%"
                        'strStats += vbCrLf
                        'End If
                        strStats += "Index Name: " + .GetString(0) + ", Type: " + _
                        .GetString(1) + ", Pages: " + .GetInt64(2).ToString("#,##0") + _
                        ", Avg. Frag: " + .GetDouble(3).ToString("#0.00") + "%"
                        strStats += vbCrLf
                    End While
                End If
                .Close()
            End With
            cnNwind.Close()
            blnGetIndexStats = False
            Return strStats
        Catch exc As Exception
            Return exc.Message
        Finally
            cnNwind.Close()
        End Try
    End Function

    Private Sub ClearTimingData()
        'Clear the text boxes and reset KB check box
        txtRows.Text = ""
        txtTime.Text = ""
        txtRowsPerSec.Text = ""
        chkBytes.Checked = False
    End Sub

    Private Sub rbXQuery1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbXQuery1.CheckedChanged
        txtOrdersXQResult.Text = ""
        txtOrderSQL.Text = "-- Uses the 'exists' method as a WHERE clause qualifier" + vbCrLf + vbCrLf
        txtOrderSQL.Text += "SELECT OrderXML1.query('for $Result in /Order return $Result') FROM Orders WHERE OrderXML1.exist('/Order[data(ShipCountry)=""USA""]') = 1;" + strClick
        btnExecuteOrders.Enabled = True
    End Sub

    Private Sub rbXQuery2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbXQuery2.CheckedChanged
        txtOrdersXQResult.Text = ""
        txtOrderSQL.Text = "-- Uses xs:date and multiple WHERE criteria for a date range (tests secondary indexes)" + vbCrLf + _
         "-- Adds renamed fields from the Customers table with a value-based join, sql:column," + vbCrLf + _
         "-- and an if ... then ... else conditional expression " + vbCrLf + vbCrLf
        '***Rev1: Each namespace declaration requires a semicolon separator (was missing)
        txtOrderSQL.Text += "SELECT OrderXML2.query('declare namespace nwso=""http://www.northwind.com/schemas/SalesOrder""; declare namespace nwbt=""http://www.northwind.com/schemas/BillTo""; for $Result in /nwso:SalesOrder return " + vbCrLf + _
         "<SalesOrder>" + vbCrLf + _
         "  <SalesOrderDate>{data($Result/@nwso:OrderDate)}</SalesOrderDate>" + vbCrLf + _
         "  <SalesOrderNum>{data($Result/@nwso:OrderID)}</SalesOrderNum>" + vbCrLf + _
         "  <Name>{data($Result/nwbt:BillTo/nwbt:Name)}</Name>" + vbCrLf + _
         "  <ShipPhone>{sql:column(""Customers.Phone"")}</ShipPhone>" + vbCrLf + _
         "  {if (not(empty(sql:column(""Customers.Fax"")))) then" + vbCrLf + _
         "     <ShipFax>{sql:column(""Customers.Fax"")}</ShipFax>" + vbCrLf + _
         "   else ()} " + vbCrLf + _
         "</SalesOrder>') " + vbCrLf + _
         "FROM Orders, Customers WHERE " + vbCrLf + _
         "OrderXML2.exist('declare namespace nwso=""http://www.northwind.com/schemas/SalesOrder""; " + vbCrLf + _
         "/nwso:SalesOrder/@nwso:OrderDate[.>= xs:dateTime(""1996-07-10T00:00:00Z"") and " + vbCrLf + _
         "  .<= xs:dateTime(""1997-07-10T00:00:00Z"")]') = 1 AND " + vbCrLf + _
         "Customers.CustomerID = OrderXML2.value('declare namespace nwso=""http://www.northwind.com/schemas/SalesOrder"";" + vbCrLf + _
         "(/nwso:SalesOrder/@nwso:CustomerID)[1]', 'nvarchar(5)'); " + strClick
        btnExecuteOrders.Enabled = True
    End Sub

    Private Sub rbXQuery3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbXQuery3.CheckedChanged
        txtOrdersXQResult.Text = ""
        txtOrderSQL.Text = "-- Examples of count, sum, average, round, concat, and string functions " + vbCrLf + vbCrLf
        txtOrderSQL.Text += "SELECT OrderXML2.query('declare namespace nwso=""http://www.northwind.com/schemas/SalesOrder""; for $Result in /nwso:SalesOrder return " + vbCrLf + _
         "<SalesOrder> " + vbCrLf + _
         "<SalesOrderNum>{data($Result/@nwso:OrderID)}</SalesOrderNum> " + vbCrLf + _
         "<SalesOrderDate>{data($Result/@nwso:OrderDate)}</SalesOrderDate> " + vbCrLf + _
         "<LineItemsCount>{count($Result/nwso:LineItems/nwso:LineItem)}</LineItemsCount> " + vbCrLf + _
         "<LineItemsValue>" + vbCrLf + _
         "{concat(""$"", xs:string(round(sum($Result/nwso:LineItems/nwso:LineItem/nwso:Extended))))} " + vbCrLf + _
         "</LineItemsValue> " + vbCrLf + _
         "<LineItemsAverage> " + vbCrLf + _
         "{concat(""$"", xs:string(round(avg($Result/nwso:LineItems/nwso:LineItem/nwso:Extended))))} " + vbCrLf + _
         "</LineItemsAverage> " + vbCrLf + _
         "</SalesOrder>') FROM Orders; " + strClick
        btnExecuteOrders.Enabled = True
    End Sub

    Private Sub rbXQueryClear_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbXQueryClear.CheckedChanged
        txtOrdersXQResult.Text = ""
        txtOrderSQL.Text = "-- Paste an XQuery expression from the XQuery.txt file in the ...\bin folder" + vbCrLf + _
         "-- or type your own XQuery expression below." + vbCrLf + vbCrLf
        btnExecuteOrders.Enabled = True
    End Sub

    Private Sub btnExecuteOrders_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecuteOrders.Click
        Dim strTemp As String = txtOrderSQL.Text
        TestOrderXMLDocuments()
        txtOrderSQL.Text = ""
        My.Application.DoEvents()
        btnExecuteOrders.Enabled = True
        txtOrderSQL.Text = strTemp
        If txtOrderSQL.Text.Length > 10 Then
            txtOrdersXQResult.Text = GetXQueryResult(txtOrderSQL.Text, "SalesOrders", 830, True, True, False)
        Else
            txtOrdersXQResult.Text = "Please type an XQuery expression in the upper text box."
        End If
    End Sub

    Private Sub TestOrderXMLDocuments()
        'Orders/SalesOrders XQuery page
        Dim intXML1Rows As Integer
        Dim intXML2Rows As Integer
        Dim strSQL As String = Nothing
        My.Application.DoEvents()
        Try
            strSQL = "SELECT COUNT(OrderID) FROM Orders " + _
             "WHERE OrderXML1 IS NOT NULL"
            cnNwind.Open()
            cmNwind.CommandText = strSQL
            intXML1Rows = CInt(cmNwind.ExecuteScalar)
            strSQL = "SELECT COUNT(OrderID) FROM Orders " + _
             "WHERE OrderXML2 IS NOT NULL"
            cmNwind.CommandText = strSQL
            intXML2Rows = CInt(cmNwind.ExecuteScalar)
            cnNwind.Close()
            If intXML1Rows = 0 Or intXML2Rows = 0 Then
                Dim strMsg As String = "The OrderXML1 and/or OrderXML2 columns " + _
                "aren't populated with XML documents, which are required for XQuery examples. " + vbCrLf + vbCrLf + _
                "Click OK to populate the columns with the default settings. " + vbCrLf + vbCrLf + _
                "Click Cancel to specify initial XML index and " + _
                "XmlSchemaCollection settings, then fill both tables."
                strMsg += "To prevent this message from appearing, set the DropXmlOrdersOnStart " + _
                  "application-level setting to False, which retains the tables' content between sessions."
                If MsgBox(strMsg, MsgBoxStyle.Information Or MsgBoxStyle.OKCancel, "OrderXML Documents are Missing") = MsgBoxResult.OK Then
                    If intXML1Rows = 0 Then
                        btnFillOrderXML1_Click(Nothing, Nothing)
                    End If
                    If intXML2Rows = 0 Then
                        btnFillOrderXML2_Click(Nothing, Nothing)
                    End If
                    intXML1Start = CInt(alOrderIDs(alOrderIDs.Count - 1)) + 1
                    intXML2Start = intXML1Start
                    'Fix up the default XQuery expression
                End If
            End If
        Catch exc As Exception
            MsgBox(exc.Message, MsgBoxStyle.Exclamation, "TestOrderXMLDocuments Exception")
        Finally
            cnNwind.Close()
        End Try
    End Sub


    Private Function GetXQueryResult(ByVal strXQL As String, ByVal strRootName As String, ByVal intMaxRows As Integer, ByVal blnSqlXml As Boolean, ByVal blnOpenConn As Boolean, ByVal blnIsRandom As Boolean) As String
        'Return the result to populate the Data text box
        Dim xrResult As XmlReader
        Dim xwSettings As XmlWriterSettings
        Dim xwResult As XmlWriter = Nothing
        sbXML = New StringBuilder()
        intRows = 0
        lngBytes = 0
        dblTime = 0
        ClearTimingData()
        xwSettings = New XmlWriterSettings
        With xwSettings
            .Encoding = Encoding.Unicode
            .Indent = True
            .IndentChars = ("  ")
            .OmitXmlDeclaration = False
            .ConformanceLevel = ConformanceLevel.Document
        End With
        'Create an XmlWriter to format the result
        xwResult = XmlWriter.Create(sbXML, xwSettings)
        'High-resolution objTimer
        objTimer = New Stopwatch
        pbFillColumn.Maximum = intMaxRows
        pbFillColumn.Value = 0
        My.Application.DoEvents()
        Try
            txtOrdersXQResult.Text = ""
            cmNwind.CommandText = strXQL
            cnNwind.Open()
            Dim sdrData As SqlDataReader
            sdrData = cmNwind.ExecuteReader
            With sdrData
                If .HasRows Then
                    'Don't include SqlConnection or SqlDataReader opening time
                    objTimer.Start()
                    Dim xmlData As SqlXml
                    'Add the root element to the XmlWriter
                    xwResult.WriteStartElement(strRootName)
                    Try
                        While .Read
                            xmlData = .GetSqlXml(0)
                            'Add child elements to the XmlWriter
                            xrResult = xmlData.CreateReader
                            xrResult.MoveToContent()
                            xwResult.WriteNode(xrResult, False)
                            Dim strTest As String = .GetValue(0).ToString
                            If (Not blnIsRandom) AndAlso intRows Mod 50 = 0 Then
                                'Display every 50 rows
                                pbFillColumn.Value = intRows
                                My.Application.DoEvents()
                            End If
                            intRows += 1
                        End While
                        'Add the end element 
                        xwResult.WriteEndElement()
                        xwResult.Flush()
                        xwResult.Close()
                    Catch exc As Exception
                        If exc.Message.Contains("Specified cast") Then
                            'It's an atomic value
                            xwResult.Close()
                            Dim objAtomic As Object = .GetValue(0)
                            sbXML.Length = 0
                            sbXML.Append(objAtomic.ToString)
                            intRows = 1
                        End If
                    End Try
                Else
                    sbXML.Append("XQuery expression returned no rows. ")
                End If
            End With

            dblTime = objTimer.ElapsedTime
            pbFillColumn.Value = pbFillColumn.Maximum
            objTimer.Done()
            lngBytes = sbXML.Length
            If dblTime < 1 Then
                'Microseconds
                txtTime.Text = dblTime.ToString("0.000000")
            Else
                'Milliseconds
                txtTime.Text = dblTime.ToString("0.000")
            End If
            If chkBytes.Checked Then
                Dim dblKB As Double
                dblKB = lngBytes / 1000
                If dblKB > 1.0 Then
                    txtRows.Text = dblKB.ToString("#0.0")
                Else
                    txtRows.Text = dblKB.ToString("0.000")
                End If
                txtRowsPerSec.Text = (dblKB / dblTime).ToString("#0.0")
            Else
                txtRows.Text = intRows.ToString("#,##0")
                txtRowsPerSec.Text = (intRows / dblTime).ToString("#,##0.00")
            End If
            'Relocated SqlDataReader.Close for accurate timing
            If Not sdrData.IsClosed Then
                sdrData.Close()
            End If
            If blnOpenConn Then
                cnNwind.Close()
            End If
            If sbXML.Length > 1000000 Then
                'Limit text returned to textbox to 1 MB
                sbXML.Length = 1000000
            End If
            Return sbXML.ToString
        Catch exc As Exception
            If exc.Message.Contains("Object reference not set") Then
                Return "XQuery expression returned NULL."
            Else
                Return exc.Message
            End If
        Finally
            cnNwind.Close()
        End Try
    End Function
End Class
